[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.51 and 1.144

version 1.51, 2021/12/07 02:42:01 version 1.144, 2022/01/07 02:16:31
Line 15 
Line 15 
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF  # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.  # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 set -o errexit -o pipefail -o nounset  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
   set +o monitor
   export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
 CFILE=SHA256.sig  CFILE=SHA256.sig
 DESTDIR=${DESTDIR:-}  DESTDIR=${DESTDIR:-}
Line 25 
Line 27 
 VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}  VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 HTTP_FWDIR="$VNAME"  HTTP_FWDIR="$VNAME"
 VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot | sed '$!d' )  VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
 [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots  [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub  FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DRYRUN=false
   VERBOSE=0
   DELETE=false
   DOWNLOAD=true
   INSTALL=true
   LOCALSRC=
   
   unset FTPPID
   unset FWPKGTMP
   REMOVE_LOCALSRC=false
   cleanup() {
           set +o errexit # ignore errors from killing ftp
           [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
           [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
           "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
   }
   trap cleanup EXIT
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have mktemp and a more hostile environment          # we have mktemp and a more hostile environment.
         if [ -x /usr/bin/mktemp ]; then          if [ -x /usr/bin/mktemp ]; then
                 _dir=$( mktemp -d "${1}-XXXXXXXXX" )                  _dir=$( mktemp -d "${1}-XXXXXXXXX" )
         else          else
Line 48 
Line 69 
 }  }
   
 fetch() {  fetch() {
         local _file=$1 _user=_file _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
   
         >"$_file"          # If we're not in the installer,
         chown "$_user" "$_file"          # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
         # If we're not in the installer, we have su(1)          (
         # and doas(1) is unlikely to be configured.          _flags=-vm
         if [ -x /usr/bin/sh ]; then          case "$VERBOSE" in
                 /usr/bin/su -s /bin/ksh "$_user" -c \                  0|1) _flags=-VM ;;
                     "/usr/bin/ftp -D 'Get/Verify' -Vm \                    2) _flags=-Vm ;;
                         -o '$_file' '${FWURL}/${_file}'"          esac
                 _exit="$?"          if [ -x /usr/bin/su ]; then
                   exec /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $_flags -o- '$_src'" > "$_dst"
         else          else
                 /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     ftp -D 'Get/Verify' -Vm \                      /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $_flags -o- "$_src" > "$_dst"
                         -o "$_file" "${FWURL}/${_file}"  
                 _exit="$?"  
         fi          fi
           ) & FTPPID=$!
           set +o monitor
   
           SECONDS=0
           _last=0
           while kill -0 -"$FTPPID" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$FTPPID" 2>/dev/null
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$FTPPID"
           _exit=$?
           set -o errexit
   
           unset FTPPID
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_file"                  rm -f "$_dst"
                 echo "Cannot fetch $_file" >&2                  echo "Cannot fetch $_src$_error" >&2
                 return 1                  return 1
         fi          fi
   }
   
         chown root "$_file"  fetch_cfile() {
           if "$DOWNLOAD"; then
                   set +o noclobber # we want to get the latest CFILE
                   fetch "$CFILE" || return 1
                   set -o noclobber
                   ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                       echo "Signature check of SHA256.sig failed" >&2 && return 1
           elif [ ! -e "$CFILE" ]; then
                   echo "${0##*/}: $CFILE: No such file or directory" >&2
                   return 2
           fi
 }  }
   
 verify() {  verify() {
           [ -e "$CFILE" ] || fetch_cfile
         # On the installer we don't get sha256 -C, so fake it.          # On the installer we don't get sha256 -C, so fake it.
         if ! fgrep -qx "SHA256 ($1) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then          if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                 echo "Checksum test for $1 failed." >&2                  echo "Checksum test for ${1##*/} failed." >&2
                 return 1                  return 1
         fi          fi
 }  }
   
 devices_needing_firmware() {  firmware_in_dmesg() {
         local _d _m _grep _dmesgtail _last=''          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
   
         grep -v '^[[:space:]]*#' "$FWPATTERNS" |          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
             while read -r _d _m; do              while read -r _d _m; do
                 _grep="grep"                  [ "$_d" = "$_last" ] && continue
                 [ "$_last" = "$_d" ] && continue                  [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                 [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "                  [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
                 [ "$_m" = "${_m#^}" ] && _grep="fgrep"  
   
                 echo "$_dmesgtail" | $_grep -q "$_m" || continue                  if [[ $_dmesgtail = *$_m* ]]; then
                 echo "$_d"                          echo "$_d"
                 _last="$_d"                          _last="$_d"
         done                  fi
               done
 }  }
   
 firmware_filename() {  firmware_filename() {
         sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d'          local _f
           [ -e "$CFILE" ] || fetch_cfile
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
   firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
 installed_firmware() {  installed_firmware() {
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          local _pre="$1" _match="$2" _post="$3" _firmware
                 [ -e "$fw" ] || continue          set -sA _firmware -- $(
               set +o noglob
               grep -Fxl '@option firmware' \
                   "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
                   2>/dev/null || true
               set -o noglob
           )
   
           [ "${_firmware[*]:-}" ] || return 0
           for fw in "${_firmware[@]}"; do
                   fw="${fw%/+CONTENTS}"
                 echo "${fw##*/}"                  echo "${fw##*/}"
         done          done
 }  }
   
   detect_firmware() {
           local _devices _last='' _d
   
           set -sA _devices -- $(
               firmware_in_dmesg
               for _d in $( installed_firmware '*' '-firmware-' '*' ); do
                   firmware_devicename "$_d"
               done
           )
   
           [ "${_devices[*]:-}" ] || return 0
           for _d in "${_devices[@]}"; do
                   [ "$_last" = "$_d" ] && continue
                   echo "$_d"
                   _last="$_d"
           done
   }
   
 add_firmware () {  add_firmware () {
         local _f="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}" _m="${2:-Install}" _pkgname
         ftp -D "Install" -Vmo- "file:${1}" |          FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \          local _flags=-vm
                 -s ",^firmware,${DESTDIR}/etc/firmware," \          case "$VERBOSE" in
                 -C / -zxphf - "+*" "firmware/*"                  0|1) _flags=-VM ;;
                   2|3) _flags=-Vm ;;
           esac
   
           ftp -N "${0##/}" -D "$_m" "$_flags" -o- "file:${1}" |
                   tar -s ",^\+,${FWPKGTMP}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
           _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
           if [ ! "$_pkgname" ]; then
                   echo "Failed to extract name from $1, partial install" 2>&1
                   rm -rf "$FWPKGTMP"
                   unset FWPKGTMP
                   return 1
           fi
   
         # TODO: Should we mark these so real fw_update can -Drepair?          # TODO: Should we mark these so real fw_update can -Drepair?
         ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL          ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
 @option manual-installation  @option manual-installation
 @option firmware  @option firmware
Line 131 
Line 244 
 .  .
 w  w
 EOL  EOL
   
           chmod 755 "$FWPKGTMP"
           mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
           unset FWPKGTMP
 }  }
   
 delete_firmware() {  delete_firmware() {
         local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
   
         # TODO: Check hash for files before deleting          # TODO: Check hash for files before deleting
         echo "Uninstalling $_pkg"          [ "$VERBOSE" -gt 2 ] && echo -n "Uninstall $_pkg ..."
         _cwd="${_pkgdir}/$_pkg"          _cwd="${_pkgdir}/$_pkg"
   
           if [ ! -e "$_cwd/+CONTENTS" ] ||
               ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                   echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                   return 2
           fi
   
         set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
   
         while read -r c g; do          while read -r c g; do
Line 148 
Line 271 
                   ;;                    ;;
                 @*) continue                  @*) continue
                   ;;                    ;;
                 *)  set -A _remove -- "$_cwd/$c" "${_remove[@]}"                  *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                   ;;                    ;;
                 esac                  esac
         done < "${_pkgdir}/${_pkg}/+CONTENTS"          done < "${_pkgdir}/${_pkg}/+CONTENTS"
Line 159 
Line 282 
                 if [ -d "$_r" ]; then                  if [ -d "$_r" ]; then
                         # Try hard not to actually remove recursively                          # Try hard not to actually remove recursively
                         # without rmdir on the install media.                          # without rmdir on the install media.
                           set +o noglob
                         [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                 else                  else
                         rm -f "$_r"                          rm -f "$_r"
                 fi                  fi
         done          done
   
           [ "$VERBOSE" -gt 2 ] && echo " done."
   
           return 0
 }  }
   
 set -A devices -- $( devices_needing_firmware )  usage() {
           echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
           exit 2
   }
   
 if [ ! "${devices:-}" ]; then  ALL=false
         echo "No devices found which need firmware files to be downloaded."  OPT_F=
         exit  while getopts :adFnp:v name
   do
          case "$name" in
          a) ALL=true ;;
          d) DELETE=true ;;
          F) OPT_F=true ;;
          n) DRYRUN=true ;;
          p) LOCALSRC="$OPTARG" ;;
          v) VERBOSE=$(( VERBOSE + 1 )) ;;
          :)
              echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
              usage 2
              ;;
          ?)
              echo "${0##*/}: unknown option -- -$OPTARG" >&2
              usage 2
              ;;
          esac
   done
   shift $((OPTIND - 1))
   
   if [ "$LOCALSRC" ]; then
           if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                   FWURL="${LOCALSRC}"
                   LOCALSRC=
           else
                   LOCALSRC="${LOCALSRC:#file:}"
                   ! [ -d "$LOCALSRC" ] &&
                       echo "The path must be a URL or an existing directory" >&2 &&
                       exit 2
           fi
 fi  fi
   
 TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )  # "Download only" means local dir and don't install
 cd "$TMPDIR"  if [ "$OPT_F" ]; then
           INSTALL=false
           LOCALSRC="${LOCALSRC:-.}"
   
 # To unpriv we need to let the unpriv user into this dir          # Always check for latest CFILE and so latest firmware
 chmod go+x .          if [ -e "$LOCALSRC/$CFILE" ]; then
                   mv "$LOCALSRC/$CFILE" "$LOCALSRC/$CFILE-OLD"
                   if fetch_cfile; then
                           rm -f "$LOCALSRC/$CFILE-OLD"
                   else
                           mv "$LOCALSRC/$CFILE-OLD" "$LOCALSRC/$CFILE"
                           echo "Using existing $CFILE" >&2
                   fi
           fi
   elif [ "$LOCALSRC" ]; then
           DOWNLOAD=false
   fi
   
 fetch "$CFILE"  if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
 ! signify -Vep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          echo "need root privileges" >&2
     echo "Signature check of SHA256.sig failed" >&2 && exit 1          exit 1
   fi
   
 for d in "${devices[@]}"; do  set -sA devices -- "$@"
         f=$( firmware_filename "$d" )  
         [ "$f" ] || continue  
         set -A installed -- $( installed_firmware "$d" )  
   
   if "$DELETE"; then
           [ "$OPT_F" ] && usage 22
   
           # Show the "Uninstalling" message when just deleting not upgrading
           [ "$VERBOSE" -gt 0 ] && VERBOSE=3
   
           set -A installed
           if [ "${devices[*]:-}" ]; then
                   "$ALL" && usage 22
   
                   set -A installed -- $(
                       for d in "${devices[@]}"; do
                           f="${d##*/}"  # only care about the name
                           f="${f%.tgz}" # allow specifying the package name
                           [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
   
                           set -A i -- $( installed_firmware '' "$f-" '*' )
   
                           if [ "${i[*]:-}" ]; then
                                   echo "${i[@]}"
                           else
                                   echo "No firmware found for '$d'" >&2
                           fi
                       done
                   )
           elif "$ALL"; then
                   set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
           fi
   
           deleted=''
         if [ "${installed:-}" ]; then          if [ "${installed:-}" ]; then
                 for i in "${installed[@]:-}"; do                  for fw in "${installed[@]}"; do
                         if [ "$f" = "$i.tgz" ]; then                          if "$DRYRUN"; then
                                 echo "$i already installed"                                  [ "$VERBOSE" -gt 0 ] && echo "Delete $fw"
                           else
                                   delete_firmware "$fw" || continue
                           fi
                           deleted="$deleted,$( firmware_devicename "$fw" )"
                   done
           fi
   
           deleted="${deleted#,}"
           echo "${0:##*/}: deleted ${deleted:-none}";
   
           exit
   fi
   
   if [ ! "$LOCALSRC" ]; then
       LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
       REMOVE_LOCALSRC=true
   fi
   
   CFILE="$LOCALSRC/$CFILE"
   
   if [ "${devices[*]:-}" ]; then
           "$ALL" && usage 22
   else
           [ "$VERBOSE" -gt 1 ] && echo -n "Detect firmware ..."
           set -sA devices -- $( detect_firmware )
           [ "$VERBOSE" -gt 1 ] &&
               { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
   fi
   
   [ "${devices[*]:-}" ] || exit
   
   added=''
   updated=''
   kept=''
   for f in "${devices[@]}"; do
           d="$( firmware_devicename "$f" )"
   
           if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
                   f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
           set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
   
           if "$INSTALL" && [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                           if [ "${f##*/}" = "$i.tgz" ]; then
                                   [ "$VERBOSE" -gt 2 ] && echo "Keep $i"
                                   kept="$kept,$d"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         fetch  "$f" || continue          if [ -e "$f" ]; then
         verify "$f" || continue                  if "$DOWNLOAD"; then
                           [ "$VERBOSE" -gt 1 ] && ! "$INSTALL" &&
                               echo "Keep/Verify ${f##*/}"
                           "$DRYRUN"  || verify "$f" || continue
                           "$INSTALL" || kept="$kept,$d"
                   # else assume it was verified when downloaded
                   fi
           elif "$DOWNLOAD"; then
                   if "$DRYRUN"; then
                           [ "$VERBOSE" -gt 0 ] && echo "Get/Verify ${f##*/}"
                   else
                           [ "$VERBOSE" -eq 1 ] && echo -n "Get/Verify ${f##*/} ..."
                           fetch  "$f" &&
                           verify "$f" ||
                               { [ "$VERBOSE" -eq 1 ] && echo " failed."; continue; }
                           [ "$VERBOSE" -eq 1 ] && ! "$INSTALL" && echo " done."
                   fi
                   "$INSTALL" || added="$added,$d"
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
           fi
   
         if [ "${installed:-}" ]; then          "$INSTALL" || continue
   
           update=''
           if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          "$DRYRUN" || delete_firmware "$i"
                           update="Update"
                 done                  done
         fi          fi
   
         add_firmware "$f"          "$DRYRUN" || add_firmware "$f" "$update"
   
           f="${f##*/}"
           f="${f%.tgz}"
           if [ "$update" ]; then
                   if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
                           echo " updated."
                   elif [ "$VERBOSE" -eq 1 ]; then
                           echo "Update $f"
                   elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                           echo "Update $f"
                   fi
                   updated="$updated,$d"
           else
                   if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
                           echo " installed."
                   elif [ "$VERBOSE" -eq 1 ]; then
                           echo "Install $f"
                   elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                           echo "Install $f"
                   fi
                   added="$added,$d"
           fi
 done  done
   
   added="${added:#,}"
   updated="${updated:#,}"
   kept="${kept:#,}"
   if "$INSTALL"; then
           echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
   else
           echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
   fi

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.144

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>